/*******************************************************************************
 * (c) Copyright 2010-2013 Microsemi SoC Products Group.  All rights reserved.
 * 
 * SmartFusion2 startup code for IAR EWARM.
 *
 * SVN $Revision: 6270 $
 * SVN $Date: 2014-03-28 12:41:48 +0000 (Fri, 28 Mar 2014) $
 */

        MODULE  ?cstartup

        ;; Forward declaration of sections.
        SECTION CSTACK:DATA:NOROOT(3)

        EXTERN  __iar_program_start
        EXTERN  SystemInit

        SECTION .text:CODE:ROOT(3)
        THUMB

;===============================================================================
; Reset_Handler
;
        PUBLIC Reset_Handler
Reset_Handler
        ;-----------------------------------------------------------------------
        ; Check if EDAC is enabled on the internal eSRAM. Initialize the stack
        ; content if EDAC is enabled.
        ;
        LDR R0, SF2_EDAC_CR
        LDR R0, [R0]
        AND R0, R0, #3
        CMP R0, #0
        BEQ call_system_init
clear_stack:
        LDR R0, CSTACK_START
        LDR R1, CSTACK_END
        LDR R2, RAM_INIT_PATTERN
        LDR R3, RAM_INIT_PATTERN
        LDR R4, RAM_INIT_PATTERN
        LDR R5, RAM_INIT_PATTERN
clear_stack_loop:
        CMP R0, R1
        IT NE
        STMNE R0!, {R2-R5}
        BNE clear_stack_loop
        
        ;-----------------------------------------------------------------------
        ; Call SystemInit() to perform Libero specified configuration.
        ;
call_system_init
        LDR     R0, =SystemInit
        BLX     R0
        
        ;-----------------------------------------------------------------------
        ; Call __iar_program_start() to perform the standard IAR program startup
        ; including copy of .data and .text sections.
        ;
        LDR     R0, =__iar_program_start
        BX      R0

        DATA

CSTACK_START        DCD     sfb(CSTACK)
CSTACK_END          DCD     sfe(CSTACK)

SF2_EDAC_CR         DC32    0x40038038
RAM_INIT_PATTERN    DC32    0x00000000

        END
